/*
**  SGSound.h
**
**  Copyright (c) 2002, 2003
**
**  Author: Yen-Ju Chen <yjchenx@hotmail.com>
**
**  This program is free software; you can redistribute it and/or modify
**  it under the terms of the GNU Lesser General Public License as published by
**  the Free Software Foundation; either version 2 of the License, or
**  (at your option) any later version.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef _Musicbox_ShengGuang_H_SGSound
#define _Musicbox_ShengGuang_H_SGSound

#include <AppKit/NSSound.h>

@class NSString;
@class NSNumber;

@interface SGSound : NSSound
{
  NSString *path;
  NSNumber *duration;
}

- (BOOL) seek: (int) seconds;
- (BOOL) isPaused;

/* This method will decode the whole file if duration is unknown,
 * which may take more time than play the file.
 * Do not use this method on big file.
 */
- (NSNumber *) duration; /* Total length in seconds */
- (void) setDuration: (NSNumber *) seconds;
- (NSNumber *) currentTime; /* Current time in seconds */

@end

#endif /* _Musicbox_ShengGuang_H_SGSound */
