/*
**  SongInfo.h
**
**  Copyright (c) 2002, 2003
**
**  Author: Yen-Ju  <yjchenx@hotmail.com>
**
**  This program is free software; you can redistribute it and/or modify
**  it under the terms of the GNU General Public License as published by
**  the Free Software Foundation; either version 2 of the License, or
**  (at your option) any later version.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef _Musicbox_ShengGuang_H_SongInfo
#define _Musicbox_ShengGuang_H_SongInfo

#include <Foundation/NSObject.h>

@class SGSound;
@class NSMutableDictionary;
@class NSSound;
@class NSString;
@class NSNumber;

@interface SongInfo : NSObject <NSCoding, NSCopying>
{
  BOOL     checked;
  NSMutableDictionary *info;
  NSSound *sound;
  /* The keys and classes are:
     song, NSString
     status, NSString
     artist, NSString
     album, NSString
     track, NSNumber
     filename, NSString
     duration, NSNumber, in seconds
   */
}

/**
 * A SGSound may not always associate with SongInfo.
 * Load a song before playing
 */
- (void) loadSound;
- (void) updateDuration;

- (NSString *) description;

// Access method
- (void) setSong: (NSString *) song;
- (NSString *) song;
- (void) setStatus: (id) status;
- (id) status;
- (void) setArtist: (NSString *) artist;
- (NSString *) artist;
- (void) setAlbum: (NSString *) album;
- (NSString *) album;
- (void) setTrack: (NSNumber *) number; 
- (NSNumber *) track;
- (void) setChecked: (BOOL) bool_;
- (BOOL) checked;
- (void) setSound: (NSSound *) sound;
- (NSSound *) sound;
- (void) setFilename: (NSString *) filename;
- (NSString *) filename;
- (void) setDuration: (NSNumber *) duration;
- (NSNumber *) duration;
- (NSNumber *) size;

@end

#endif /* _Musicbox_ShengGuang_H_SongInfo */
